'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

exports.one = one;
exports.all = all;

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _marked = [one, all].map(_regenerator2.default.mark);

// Fields that should be excluded from the response
var remove = ['_id', 'id', 'password', '__v', 'aliases', 'metadata', 'chunkSize', 'md5'];

var models = ['page', 'user', 'file'];

var _iteratorNormalCompletion = true;
var _didIteratorError = false;
var _iteratorError = undefined;

try {
  for (var _iterator = (0, _getIterator3.default)(models), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
    var model = _step.value;

    // Load models and add them to the "models" object
    models[model] = require('../models/' + model).default;
  }
} catch (err) {
  _didIteratorError = true;
  _iteratorError = err;
} finally {
  try {
    if (!_iteratorNormalCompletion && _iterator.return) {
      _iterator.return();
    }
  } finally {
    if (_didIteratorError) {
      throw _iteratorError;
    }
  }
}

function one(type, _id) {
  var query, item, attributes, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, property;

  return _regenerator2.default.wrap(function one$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          query = models[type].where({ _id: _id });
          item = false;
          _context.prev = 2;
          _context.next = 5;
          return query.findOne();

        case 5:
          item = _context.sent;
          _context.next = 11;
          break;

        case 8:
          _context.prev = 8;
          _context.t0 = _context['catch'](2);
          return _context.abrupt('return', (0, _utils.log)('Couldn\'t load ' + type + 's', _context.t0));

        case 11:
          attributes = item.toObject();
          _iteratorNormalCompletion2 = true;
          _didIteratorError2 = false;
          _iteratorError2 = undefined;
          _context.prev = 15;


          for (_iterator2 = (0, _getIterator3.default)(remove); !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            property = _step2.value;

            delete attributes[property];
          }

          _context.next = 23;
          break;

        case 19:
          _context.prev = 19;
          _context.t1 = _context['catch'](15);
          _didIteratorError2 = true;
          _iteratorError2 = _context.t1;

        case 23:
          _context.prev = 23;
          _context.prev = 24;

          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }

        case 26:
          _context.prev = 26;

          if (!_didIteratorError2) {
            _context.next = 29;
            break;
          }

          throw _iteratorError2;

        case 29:
          return _context.finish(26);

        case 30:
          return _context.finish(23);

        case 31:
          return _context.abrupt('return', {
            id: _id,
            type: type.toLowerCase(),
            attributes: attributes
          });

        case 32:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked[0], this, [[2, 8], [15, 19, 23, 31], [24,, 26, 30]]);
}

function all(type) {
  var plural, items, list, item, attributes, id, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, property;

  return _regenerator2.default.wrap(function all$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          plural = type + 's';
          items = false;
          _context2.prev = 2;
          _context2.next = 5;
          return models[type].find();

        case 5:
          items = _context2.sent;
          _context2.next = 11;
          break;

        case 8:
          _context2.prev = 8;
          _context2.t0 = _context2['catch'](2);
          return _context2.abrupt('return', (0, _utils.log)('Couldn\'t load ' + plural, _context2.t0));

        case 11:
          list = [];
          _context2.t1 = _regenerator2.default.keys(items);

        case 13:
          if ((_context2.t2 = _context2.t1()).done) {
            _context2.next = 39;
            break;
          }

          item = _context2.t2.value;
          attributes = items[item].toObject();
          id = attributes.id || attributes._id;
          _iteratorNormalCompletion3 = true;
          _didIteratorError3 = false;
          _iteratorError3 = undefined;
          _context2.prev = 20;


          for (_iterator3 = (0, _getIterator3.default)(remove); !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            property = _step3.value;

            delete attributes[property];
          }

          _context2.next = 28;
          break;

        case 24:
          _context2.prev = 24;
          _context2.t3 = _context2['catch'](20);
          _didIteratorError3 = true;
          _iteratorError3 = _context2.t3;

        case 28:
          _context2.prev = 28;
          _context2.prev = 29;

          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }

        case 31:
          _context2.prev = 31;

          if (!_didIteratorError3) {
            _context2.next = 34;
            break;
          }

          throw _iteratorError3;

        case 34:
          return _context2.finish(31);

        case 35:
          return _context2.finish(28);

        case 36:
          list.push({
            id: id,
            type: plural,
            attributes: attributes
          });
          _context2.next = 13;
          break;

        case 39:
          return _context2.abrupt('return', list);

        case 40:
        case 'end':
          return _context2.stop();
      }
    }
  }, _marked[1], this, [[2, 8], [20, 24, 28, 36], [29,, 31, 35]]);
}