"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.log = log;

var _chalk = require("chalk");

var _chalk2 = _interopRequireDefault(_chalk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function log(message, err) {
  // Regular errors
  if (message instanceof Error) {
    console.error(err && err.stack);
    return;
  }

  // Ability to add custom message to error
  if (err instanceof Error) {
    console.error(_chalk2.default.bold(message) + "\n", err.stack);
    return;
  }

  // The usual loggings
  console.log(message);
}