'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _koaRouter = require('koa-router');

var _koaRouter2 = _interopRequireDefault(_koaRouter);

var _koaJwt = require('koa-jwt');

var _koaJwt2 = _interopRequireDefault(_koaJwt);

var _user = require('../../models/user');

var _user2 = _interopRequireDefault(_user);

var _utils = require('../../lib/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var router = (0, _koaRouter2.default)();

router.post('/token-auth', _regenerator2.default.mark(function _callee(next) {
  var body, query, user, isMatch, token;
  return _regenerator2.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          body = this.request.body;

          if (!(!body.username || !body.password)) {
            _context.next = 5;
            break;
          }

          this.status = 400;
          this.body = {
            error: 'User and/or password empty'
          };
          return _context.abrupt('return');

        case 5:
          query = _user2.default.where({ _id: body.username });
          user = false;
          _context.prev = 7;
          _context.next = 10;
          return query.findOne();

        case 10:
          user = _context.sent;
          _context.next = 16;
          break;

        case 13:
          _context.prev = 13;
          _context.t0 = _context['catch'](7);

          (0, _utils.log)('Couldn\'t load user', _context.t0);

        case 16:
          if (user) {
            _context.next = 20;
            break;
          }

          this.status = 400;
          this.body = {
            error: 'User doesn\'t exist'
          };

          return _context.abrupt('return');

        case 20:

          // Compare password with the one within the DB
          isMatch = user.tryPassword(body.password);

          if (!isMatch) {
            _context.next = 25;
            break;
          }

          token = _koaJwt2.default.sign(body, process.env.SESSION_SECRET, {
            expiresIn: 300
          });


          this.body = {
            token: token
          };

          return _context.abrupt('return');

        case 25:

          this.status = 400;

          this.body = {
            error: 'Wrong password'
          };

          _context.next = 29;
          return next;

        case 29:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, this, [[7, 13]]);
}));

router.post('/token-refresh', _regenerator2.default.mark(function _callee2(next) {
  var token, decoded, query, user, isMatch;
  return _regenerator2.default.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          token = this.request.body.token;
          decoded = false;
          _context2.prev = 2;

          decoded = _koaJwt2.default.verify(token, process.env.SESSION_SECRET);
          _context2.next = 11;
          break;

        case 6:
          _context2.prev = 6;
          _context2.t0 = _context2['catch'](2);

          this.status = 401;
          this.body = { error: _context2.t0 };

          return _context2.abrupt('return');

        case 11:
          query = _user2.default.where({ _id: decoded.username });
          user = false;
          _context2.prev = 13;
          _context2.next = 16;
          return query.findOne();

        case 16:
          user = _context2.sent;
          _context2.next = 22;
          break;

        case 19:
          _context2.prev = 19;
          _context2.t1 = _context2['catch'](13);

          (0, _utils.log)('Couldn\'t load user', _context2.t1);

        case 22:
          if (user) {
            _context2.next = 26;
            break;
          }

          this.status = 401;
          this.body = {
            error: 'User doesn\'t exist'
          };

          return _context2.abrupt('return');

        case 26:
          isMatch = user.tryPassword(decoded.password);

          if (!isMatch) {
            _context2.next = 30;
            break;
          }

          this.body = {
            token: _koaJwt2.default.sign(decoded, process.env.SESSION_SECRET, {
              expiresIn: 300
            })
          };

          return _context2.abrupt('return');

        case 30:

          this.status = 401;

          this.body = {
            error: 'Wrong password'
          };

          _context2.next = 34;
          return next;

        case 34:
        case 'end':
          return _context2.stop();
      }
    }
  }, _callee2, this, [[2, 6], [13, 19]]);
}));

module.exports = router;