'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _koaRouter = require('koa-router');

var _koaRouter2 = _interopRequireDefault(_koaRouter);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _db = require('../../lib/db');

var _utils = require('../../lib/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var router = (0, _koaRouter2.default)();

function detSeparator(handle) {
  var numbers = {};

  var types = {
    spaces: ' ',
    dots: '.',
    underscores: '_',
    dashes: '-'
  };

  for (var type in types) {
    if (!types.hasOwnProperty(type)) {
      continue;
    }

    numbers[type] = handle.split(types[type]).length - 1;
  }

  var largest = (0, _keys2.default)(numbers).reduce(function (prev, curr) {
    return numbers[prev] > numbers[curr] ? prev : curr;
  });

  return types[largest];
}

router.get('/files', require('../uploads').routes());

router.post('/upload', _regenerator2.default.mark(function _callee(next) {
  var file, ext, name, separator, id, formatName, isAvailable, writestream, content;
  return _regenerator2.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          formatName = function formatName(n) {
            return encodeURIComponent(name + (n > 0 ? separator + n : '') + ext);
          };

          file = this.request.body.files.file;
          ext = _path2.default.extname(file.name);
          name = _path2.default.basename(file.name, ext);

          // Determine the most used separator in the filename

          separator = detSeparator(name);
          id = 0;

          // Encode filename as URI string

          isAvailable = false;

        case 7:
          _context.prev = 7;
          _context.next = 10;
          return _db.fs.exist({
            filename: formatName(id),
            root: 'media'
          });

        case 10:
          isAvailable = _context.sent;
          _context.next = 16;
          break;

        case 13:
          _context.prev = 13;
          _context.t0 = _context['catch'](7);
          return _context.abrupt('return', (0, _utils.log)('Couldn\'t check if media exists', _context.t0));

        case 16:
          if (!isAvailable) {
            _context.next = 20;
            break;
          }

          id++;
          _context.next = 21;
          break;

        case 20:
          return _context.abrupt('break', 22);

        case 21:
          if (true) {
            _context.next = 7;
            break;
          }

        case 22:
          writestream = _db.fs.createWriteStream({
            filename: formatName(id),
            root: 'media',
            content_type: file.type
          });

          // Get file from disk and pipe it to gfs's writestream

          content = _fsExtra2.default.createReadStream(file.path);

          content.pipe(writestream);

          _context.prev = 25;
          _context.next = 28;
          return new _promise2.default(function (resolve) {
            writestream.on('close', function () {
              return resolve();
            });
          });

        case 28:
          _context.next = 33;
          break;

        case 30:
          _context.prev = 30;
          _context.t1 = _context['catch'](25);
          return _context.abrupt('return', (0, _utils.log)('Not able to save media', _context.t1));

        case 33:

          this.body = {
            contentType: file.type,
            uploadDate: new Date().toJSON()
          };

          _context.next = 36;
          return next;

        case 36:

          // Remove temporary file after response
          _fsExtra2.default.unlink(file.path, function (err) {
            if (err) (0, _utils.log)('Couldn\'t remove temporary media file', err);
          });

        case 37:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, this, [[7, 13], [25, 30]]);
}));

module.exports = router;