'use strict';

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _koaRouter = require('koa-router');

var _koaRouter2 = _interopRequireDefault(_koaRouter);

var _utils = require('../lib/utils');

var _page = require('../models/page');

var _page2 = _interopRequireDefault(_page);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var router = (0, _koaRouter2.default)();

var details = {
  site: {
    title: 'Peter Griffin'
  },
  year: new Date().getFullYear()
};

router.use(_regenerator2.default.mark(function _callee(next) {
  var pages, page;
  return _regenerator2.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          pages = false;
          _context.prev = 1;
          _context.next = 4;
          return _page2.default.find().sort({ _id: 1 });

        case 4:
          pages = _context.sent;
          _context.next = 10;
          break;

        case 7:
          _context.prev = 7;
          _context.t0 = _context['catch'](1);

          (0, _utils.log)('Couldn\'t load pages', _context.t0);

        case 10:
          if (pages) {
            _context.next = 14;
            break;
          }

          this.status = 500;
          this.body = 'Couldn\'t load pages';
          return _context.abrupt('return');

        case 14:

          for (page in pages) {
            pages[page] = pages[page].toObject();
          }

          this.pages = pages;
          _context.next = 18;
          return next;

        case 18:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, this, [[1, 7]]);
}));

router.get('*', _regenerator2.default.mark(function _callee2(next) {
  var path, result;
  return _regenerator2.default.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          details.site.canonical = this.request.origin;
          path = this.request.url;
          _context2.next = 4;
          return next;

        case 4:

          details.pages = this.pages;
          result = false;
          _context2.prev = 6;
          _context2.next = 9;
          return _page2.default.findOne({
            slug: path.split('/')[1]
          });

        case 9:
          result = _context2.sent;
          _context2.next = 15;
          break;

        case 12:
          _context2.prev = 12;
          _context2.t0 = _context2['catch'](6);

          (0, _utils.log)('Not able to load page', _context2.t0);

        case 15:
          if (result) {
            _context2.next = 17;
            break;
          }

          return _context2.abrupt('return');

        case 17:

          (0, _assign2.default)(details, result.toObject());

          if (!(path === '/')) {
            _context2.next = 22;
            break;
          }

          _context2.next = 21;
          return this.render('index', details);

        case 21:
          return _context2.abrupt('return');

        case 22:
          _context2.next = 24;
          return this.render('page', details);

        case 24:
        case 'end':
          return _context2.stop();
      }
    }
  }, _callee2, this, [[6, 12]]);
}));

module.exports = router;