'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _koaRouter = require('koa-router');

var _koaRouter2 = _interopRequireDefault(_koaRouter);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _utils = require('../lib/utils');

var _db = require('../lib/db');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var router = (0, _koaRouter2.default)();

router.get('/', _regenerator2.default.mark(function _callee(next) {
  var query, isAvailable, stream, metaData, meta;
  return _regenerator2.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          query = {
            filename: _path2.default.basename(this.request.originalUrl),
            root: 'media'
          };
          isAvailable = false;
          _context.prev = 2;
          _context.next = 5;
          return _db.fs.exist(query);

        case 5:
          isAvailable = _context.sent;
          _context.next = 11;
          break;

        case 8:
          _context.prev = 8;
          _context.t0 = _context['catch'](2);

          (0, _utils.log)('Not able to load file', _context.t0);

        case 11:
          if (isAvailable) {
            _context.next = 14;
            break;
          }

          this.body = 'File doesn\'t exist!';
          return _context.abrupt('return');

        case 14:

          // Read the requested file from the DB
          stream = _db.fs.createReadStream(query);


          stream.on('error', _utils.log);

          // Try to get the file's meta data and give back an error if one appears
          metaData = new _promise2.default(function (resolve, reject) {
            _db.fs.findOne(query, function (err, meta) {
              if (err) {
                return reject(err);
              }

              resolve(meta);
            });
          });
          meta = {};
          _context.prev = 18;
          _context.next = 21;
          return metaData;

        case 21:
          meta = _context.sent;
          _context.next = 27;
          break;

        case 24:
          _context.prev = 24;
          _context.t1 = _context['catch'](18);
          return _context.abrupt('return', (0, _utils.log)('Not able to get file meta', _context.t1));

        case 27:

          // Tell the client how to treat the data
          this.set({
            'Content-Type': meta.contentType,
            'Content-Length': meta.length,
            'Cache-Control': 'max-age=31536000'
          });

          // Send filestream to client
          this.body = stream;

          _context.next = 31;
          return next;

        case 31:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, this, [[2, 8], [18, 24]]);
}));

module.exports = router;